#include "code/framework/check/PrettyFileLogger.h"
#include <iostream>
#include <fstream>
#include "code/framework/utils.h"
#include "code/framework/check/loaders.h"
#include <pspsysmem.h>
#include <pspthreadman.h>


using namespace utils;
using namespace std;

int PrettyFileLogger::m_nb_indents=0;
ofstream PrettyFileLogger::m_outfile;
//unsigned int PrettyFileLogger::m_interrupt=0;

PrettyFileLogger::PrettyFileLogger()
{
}

PrettyFileLogger::~PrettyFileLogger()
{
	
}

void PrettyFileLogger::onBegin()
{
	//m_interrupt=pspSdkDisableInterrupts();
	
	if(!m_outfile.is_open())
		fwkOpenTextFile(PFL_LOG_FILE, &m_outfile, ios_base::app);
	
	//m_outfile << sceKernelTotalFreeMemSize() << "   " << sceKernelMaxFreeMemSize() << "   " << sceKernelGetThreadStackFreeSize(0) << "\t\t";
	
	//struct mallinfo mi1=mallinfo();
	m_outfile << mallinfo().fordblks << "  \t\t";
	
	writeIndents();
}

void PrettyFileLogger::onEnd()
{
	//m_outfile << "\t\t\t\t\t\t\t\t\t" << sceKernelTotalFreeMemSize() << "\t\t" << sceKernelMaxFreeMemSize() << "\t\t" << sceKernelGetThreadStackFreeSize(0) << "\r\n";
	m_outfile.flush();
	m_outfile.close();
	if(m_outfile.bad())
		fatalError("PrettyFileLogger::onEnd : couldn't flush or close");
	
	//pspSdkEnableInterrupts(m_interrupt);
}

void PrettyFileLogger::writeIndents()
{
	for(int i=0;i<m_nb_indents;i++)
	{
		m_outfile << "\t";
	}
}

void PrettyFileLogger::logConstructionStart(string object)
{
	onBegin();
	m_outfile << "construction " << object << " start..." << "\r\n";
	onEnd();
  	m_nb_indents++;
  
}

void PrettyFileLogger::logConstructionEnd(string object)
{
  	m_nb_indents--;
	onBegin();
	m_outfile << "construction " << object << " done." << "\r\n" << "\r\n";
	onEnd();
}

void PrettyFileLogger::logDestructionStart(string object)
{
	onBegin();
	m_outfile << "destruction " << object << " start..." << "\r\n";
	onEnd();
  	m_nb_indents++;
}

void PrettyFileLogger::logDestructionEnd(string object)
{
  	m_nb_indents--;
	onBegin();
	m_outfile << "destruction " << object << " done." << "\r\n" <<"\r\n";
	onEnd();
}

void PrettyFileLogger::logFunctionStart(string object)
{
	onBegin();
	m_outfile << object << " start..." << "\r\n";
	onEnd();
  	m_nb_indents++;
}

void PrettyFileLogger::logFunctionEnd(string object)
{
	m_nb_indents--;
	onBegin();
	m_outfile << object << " done." << "\r\n" <<"\r\n";
	onEnd();
}

void PrettyFileLogger::logMessage(string message)
{
	onBegin();
	m_outfile << message << "\r\n";
	onEnd();
}

