#ifndef TRACKABLE_H_
#define TRACKABLE_H_

#include <map>
#include <string>

using namespace std;

class Trackable
{
	private:
		static map<string, int> m_allocations;
		static map<string, int> m_unallocations;
		
		static bool m_istracking;
		
		string m_classname;
	
	public:
		Trackable(string classname, int id=-1);
		virtual ~Trackable();
		Trackable(const Trackable & trackable);
		Trackable& operator =(const Trackable& trackable);
		
		static void startTracking();
		static void stopTracking();
		static void dumpToFile(string filename="trackable_dump.txt");
		static void zeroAll();
};

#endif /*TRACKABLE_H_*/
