#include "code/framework/check/loaders.h"

OSL_IMAGE *fwkLoadImageFilePNG(string filename, int location, int pixelFormat)
{
	sceDisplayWaitVblankStart();
	OSL_IMAGE *img=oslLoadImageFilePNG((char *)filename.c_str(), location, pixelFormat);
	if(img==NULL)
	{
		//TODO: enlever ca
		//test: on essaie encore
		for(int i=0;i<60;i++)
			sceDisplayWaitVblankStart();
		img=oslLoadImageFilePNG((char *)filename.c_str(), location, pixelFormat);
		if(img==NULL)
			fatalError("could not load png even after a retry : "+filename);
		else
			message("succeeded to open png after a retry: "+filename+"\nPlease let me know: daaa57150 on qj.net");
	}
	return img;
}

OSL_SOUND *fwkLoadSoundFileMP3(string filename, int stream)
{
	sceDisplayWaitVblankStart();
	if(stream==OSL_FMT_NONE)
		fatalError("cannot load an mp3 without streaming. file is : "+filename);
	OSL_SOUND *snd=oslLoadSoundFileMP3(filename.c_str(), stream);
	if(snd==NULL)
	{
		fatalError("could not load mp3 : "+filename);
	}
	return snd;
}

OSL_SOUND *fwkLoadSoundFileWAV(string filename, int stream)
{
	sceDisplayWaitVblankStart();
	OSL_SOUND *snd=oslLoadSoundFileWAV(filename.c_str(), stream);
	if(snd==NULL)
	{
		fatalError("could not load wav : "+filename);
	}
	return snd;
}

OSL_SOUND *fwkLoadSoundFileBGM(string filename, int stream)
{
	sceDisplayWaitVblankStart();
	OSL_SOUND *snd=oslLoadSoundFileBGM(filename.c_str(), stream);
	if(snd==NULL)
	{
		fatalError("could not load bgm : "+filename);
	}
	return snd;
}

void fwkOpenTextFile(string filename, ofstream *file)
{
	sceDisplayWaitVblankStart();
	file->open(filename.c_str());
	if(/*file->fail() || file->bad()*/ !file->good())
	{
		fatalError("could not open text file : "+filename);
	}
}


void fwkOpenTextFile(string filename, ofstream *file, ios_base::openmode mode)
{
	sceDisplayWaitVblankStart();
	file->open(filename.c_str(), mode);
	if(/*file->fail() || file->bad()*/ !file->good())
	{
		fatalError("could not open text file : "+filename);
	}
}

void fwkOpenTextFile(string filename, ifstream *file)
{
	sceDisplayWaitVblankStart();
	file->open(filename.c_str());
	if(/*file->fail() || file->bad()*/ !file->good())
	{
		fatalError("could not open text file : "+filename);
	}
}


void fwkOpenTextFile(string filename, ifstream *file, ios_base::openmode mode)
{
	sceDisplayWaitVblankStart();
	file->open(filename.c_str(), mode);
	if(/*file->fail() || file->bad()*/ !file->good())
	{
		fatalError("could not open text file : "+filename);
	}
}


void fwkDeleteSound(OSL_SOUND *snd)
{
	oslStopSound(snd);
	for(int i=0;i<20;i++)
		sceDisplayWaitVblankStart();
	oslDeleteSound(snd);
	for(int i=0;i<20;i++)
		sceDisplayWaitVblankStart();
}















