#ifndef PROGRESSIVEALPHAEFFECT_H_
#define PROGRESSIVEALPHAEFFECT_H_
#include "code/framework/fx/abstract/AbstractGlobalEffect.h"

class ProgressiveAlphaEffect : public AbstractGlobalEffect
{
	private:
		int m_timeAB;
		int m_timeBA;
		bool m_running;
		int m_curTick;
		int m_from;
		int m_to;
		int m_nbLoops;
		int m_currentLoop;
		bool m_aToB;
		
		//helpers pour fonction activate
		OSL_ALPHA_PARAMS *m_alpha;
		u8 * m_curColor;
		u8 m_newAlpha;
	
	public:
		ProgressiveAlphaEffect(int timeAB, int timeBA, int from, int to, int nbLoops=-1);
		~ProgressiveAlphaEffect();
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		void activate();
		ProgressiveAlphaEffect* clone() const;
	
		void setTimeForward(int time);
		int getTimeForward();
		void setTimeBackward(int time);
		int getTimeBackward();
		void setNbLoops(int nb);
		int getCurrentAlpha();

};

#endif /*PROGRESSIVEALPHAEFFECT_H_*/
