#ifndef PROGRESSIVETINTEFFECT_H_
#define PROGRESSIVETINTEFFECT_H_
#include "code/framework/fx/abstract/AbstractGlobalEffect.h"

class ProgressiveTintEffect : public AbstractGlobalEffect
{
	private:
		int m_timeAB;
		int m_timeBA;
		bool m_running;
		int m_curTick;
		u8 *m_colorFrom;
		u8 *m_colorTo;
		int m_nbLoops;
		int m_currentLoop;
		bool m_aToB;
		
		float *m_diffFrames; //tableau de difference entre frames
		float *m_current; //tableau avec la couleur actuelle
		
		//helpers pour fonction activate
		OSL_ALPHA_PARAMS *m_alpha;
		u8 * m_curColor;
		u8 * m_newColor;
	
	public:
		ProgressiveTintEffect(int timeAB, int timeBA, u32 colorFrom, u32 colorTo, int nbLoops=-1);
		~ProgressiveTintEffect();
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		void activate();
		ProgressiveTintEffect* clone() const;
		
		void setTimeForward(int time);
		int getTimeForward();
		void setTimeBackward(int time);
		int getTimeBackward();
		u32 getCurrentColor();
		void setColorTo(u32 color);
		void setColorFrom(u32 color);
		void setColors(u32 from, u32 to);
		void setNbLoops(int nb);
};

#endif /*PROGRESSIVETINTEFFECT*/
