#include "code/framework/fx/impl/local/BlinkEffect.h"

BlinkEffect::BlinkEffect(unsigned int onDuration, unsigned int offDuration, bool startsOn, short nbBlinks)//-1 = infinite
{
	m_nbBlinks=nbBlinks;
	m_offDuration=offDuration;
	m_onDuration=onDuration;
	m_on=startsOn;
	m_running=false;
	m_startsOn=startsOn;
	m_currentTick=0;
	m_currentBlink=0;
} 
	
void BlinkEffect::start()
{
	m_running=true;
}

void BlinkEffect::restart()
{
	m_on=m_startsOn;
	m_running=true;
	m_currentTick=0;
	m_currentBlink=0;
}

void BlinkEffect::reset()
{
	m_on=m_startsOn;
	m_currentTick=0;
	m_currentBlink=0;
}

void BlinkEffect::stop()
{
	m_running=false;
}

void BlinkEffect::update()
{
	if(m_running)
	{
		m_currentTick++;
		if((m_on && m_currentTick==m_onDuration) || (!m_on && m_currentTick==m_offDuration))
		{
			m_currentBlink++;
			m_on=!m_on; //interverti
			m_currentTick=0;
		}
		
		if(finished())
		{
			m_running=false;	
			return;
		}
	}
}

bool BlinkEffect::finished()
{
	if(m_nbBlinks==-1) //infini
		return false; //ca fini jamais
	//else:
	if
	(m_currentBlink==m_nbBlinks && 
		(
			/*(m_on && m_currentTick-1==m_onDuration) || 
			(!m_on && m_currentTick-1==m_offDuration)*/
			m_currentTick==0
		)
	)
	{
		m_on=!m_on; //parce que on l'a fait une fois de trop dans l'update
		return true;
	}
	return false;
}

bool BlinkEffect::isRunning()
{
	return m_running;
}

OSL_IMAGE * BlinkEffect::applyOn(OSL_IMAGE *img)
{
	if(m_on)
		return img;
	return NULL;
}

/*OSL_IMAGE * BlinkEffect::unapplyOn(OSL_IMAGE *img)
{
	return img; //on l'a pas touchée
}*/

BlinkEffect* BlinkEffect::clone() const
{
	return new BlinkEffect(m_onDuration, m_offDuration, m_startsOn, m_nbBlinks);
}

void BlinkEffect::setOnTime(unsigned int time)
{
	m_onDuration=time;
}

unsigned int BlinkEffect::getOnTime()
{
	return m_onDuration;
}

void BlinkEffect::setOffTime(unsigned int time)
{
	m_offDuration=time;
}

unsigned int BlinkEffect::getOffTime()
{
	return m_offDuration;
}

Positionable *BlinkEffect::applyOnPositionable(Positionable *obj)
{
	if(m_on)
		return obj;
	return NULL;
}

Orientable *BlinkEffect::applyOnOrientable(Orientable *obj)
{
	if(m_on)
		return obj;
	return NULL;
}

Resizable *BlinkEffect::applyOnResizable(Resizable *obj)
{
	if(m_on)
		return obj;
	return NULL;
}








