#ifndef BLINKEFFECT_H_
#define BLINKEFFECT_H_

#include "code/framework/fx/abstract/AbstractLocalEffect.h"

//effet local
//permet d'afficher une image pendant un certain temps, puis plus rien
class BlinkEffect : public AbstractLocalEffect
{
	private:
		bool m_running;
		unsigned int m_onDuration;
		unsigned int m_offDuration;
		bool m_on;  //on ou off?
		short m_nbBlinks;
		bool m_startsOn;
		unsigned int m_currentTick;
		unsigned short m_currentBlink;
		
	
	public:
		BlinkEffect(unsigned int onDuration, unsigned int offDuration, bool startsOn=true, short nbBlinks=-1); //-1 = infinite
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		OSL_IMAGE * applyOn(OSL_IMAGE *);
		Positionable *applyOnPositionable(Positionable *obj);
		Orientable *applyOnOrientable(Orientable *obj);
		Resizable *applyOnResizable(Resizable *obj);
		
		BlinkEffect* clone() const;	
		
		void setOnTime(unsigned int time);	
		unsigned int getOnTime();
		void setOffTime(unsigned int time);
		unsigned int getOffTime();
};



#endif /*BLINKEFFECT_H_*/
