#ifndef REMANENTEFFECT_H_
#define REMANENTEFFECT_H_

#include "code/framework/fx/abstract/AbstractLocalEffect.h"

//effet local
//permet d'afficher une image pendant un certain temps, puis plus rien
class RemanentEffect : public AbstractLocalEffect
{
	private:
		unsigned int m_duration;
		unsigned int m_current;
		bool m_running;
		
	
	public:
		RemanentEffect(unsigned int duration);
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		OSL_IMAGE * applyOn(OSL_IMAGE *);
		Positionable *applyOnPositionable(Positionable *obj);
		Orientable *applyOnOrientable(Orientable *obj);
		Resizable *applyOnResizable(Resizable *obj);
		RemanentEffect* clone() const;	 
};

#endif /*REMANENTEFFECT_H_*/
