#ifndef ROTATIONEFFECT_H_
#define ROTATIONEFFECT_H_

#include "code/framework/fx/abstract/AbstractLocalEffect.h"

//effet local
class RotationEffect : public AbstractLocalEffect
{
	private:
		bool m_running;
		unsigned int m_time;
		bool m_clockwise;
		int m_nbLoops;
		unsigned int m_curTime;
		int m_curLoop;		
		
	
	public:
		RotationEffect(unsigned int revolutionTime, bool direction=true, int nbLoops=-1); //-1 = infinite
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		OSL_IMAGE * applyOn(OSL_IMAGE *); 
		Orientable *applyOnOrientable(Orientable *obj);
		RotationEffect* clone() const;
		
		
		void setRevolutionTime(unsigned int time);
		unsigned int getRevolutionTime();
		
		int getOrientation();
};

#endif /*ROTATIONEFFECT_H_*/
