#ifndef SHAKEEFFECT_H_
#define SHAKEEFFECT_H_
#include "code/framework/fx/abstract/AbstractLocalEffect.h"
#include "code/framework/interfaces/Positionable.h"
#include "code/framework/Pos.h"

class ShakeEffect  : public AbstractLocalEffect
{
	private:
		int m_time;
		float m_time_2; //la moitié du temps, pour pas refaire le calcul a chaque fois
		
		bool m_running;
		int m_curTime;
		bool m_direction;
		int m_nbLoops;
		int m_curLoop;
		
		int m_distXLeft; //distance a parcourir vers la gauche
		int m_distXRight; //vers la droite
		int m_distYUp; //vers le haut
		int m_distYDown; //vers le bas
		
		bool m_position; //gauche bas (true) ou droite haut (false)?
		
		bool m_startDirection;
		
		Pos m_pos_diff;
		
		Pos calculateDiff();
	
	public:
		//mettre des valeurs de width/height négatives fait aller dans l'autre sens
		ShakeEffect(int width, int height, int time, bool direction=true, int nbLoops=-1);
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		OSL_IMAGE * applyOn(OSL_IMAGE *); 
		Positionable *applyOnPositionable(Positionable *obj);
		
		ShakeEffect* clone() const;
		
		void setTime(int time);
		int getTime();
		
		int getPosX();
		int getPosY();
};
#endif /*SHAKEEFFECT_H_*/











