#include "code/framework/particles/complete/animFactories/abstract/AbstractAnimationFactory.h"
#include "code/framework/particles/complete/animFactories/RandomAnimationFactory.h"
#include "code/framework/utils.h"

RandomAnimationFactory::RandomAnimationFactory(Anim *anim)
{
	m_animations=new vector<Anim *>();
	if(anim!=NULL)
		m_animations->push_back(anim);
}

RandomAnimationFactory *RandomAnimationFactory::clone() const
{
	RandomAnimationFactory *theclone=new RandomAnimationFactory();
	
	vector<Anim *>::iterator it;
	for (it=m_animations->begin() ; it < m_animations->end(); it++ )
    {
    	Anim *anim=*it;
    	theclone->addAnimation(new Anim(*anim));
    }
	
	return theclone;
}

RandomAnimationFactory::~RandomAnimationFactory()
{
	vector<Anim *>::iterator it;
	for (it=m_animations->begin(); it!=m_animations->end();it++)
    {
    	delete (*it);
    }
    delete m_animations;
}

void RandomAnimationFactory::addAnimation(Anim *anim)
{
	m_animations->push_back(anim);
}

Anim *RandomAnimationFactory::newAnimInstance()
{
	int rand=utils::random(0, m_animations->size()-1);
	Anim* anim=m_animations->at((unsigned int)(rand));
	return new Anim(*anim);
}

float RandomAnimationFactory::getDelayTotal()
{
	return m_animations->at(0)->getDelayTotal();
}

void RandomAnimationFactory::setDelayTotal(float d)
{
	vector<Anim *>::iterator it;
	for (it=m_animations->begin(); it!=m_animations->end();it++)
    {
    	(*it)->setDelayTotal(d);
    }
}





