#ifndef PARTICLESPROGRESSIVETINTEFFECT_H_
#define PARTICLESPROGRESSIVETINTEFFECT_H_
#include "code/framework/fx/abstract/AbstractGlobalEffect.h"
#include "code/framework/fx/EffectsLib.h"

class ParticlesProgressiveTintEffect : public AbstractGlobalEffect
{
	private:
		int m_timeAB;
		int m_timeBA;
		bool m_running;
		int m_curTick;
		u8 *m_colorFrom;
		u8 *m_colorTo;
		int m_nbLoops;
		int m_currentLoop;
		bool m_aToB;
	
	public:
		ParticlesProgressiveTintEffect(int timeAB, int timeBA, u32 colorFrom, u32 colorTo, int nbLoops=-1);
		~ParticlesProgressiveTintEffect();
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		void activate();
		ParticlesProgressiveTintEffect* clone() const;
		
		void setTimeForward(int time);
		int getTimeForward();
		void setTimeBackward(int time);
		int getTimeBackward();
};

#endif /*PARTICLESPROGRESSIVETINTEFFECT*/
