#include "code/framework/particles/complete/fxFactories/PFXFRandomColor.h"
#include <oslib/oslib.h>
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/utils.h"

using namespace utils;
using namespace std;

PFXFRandomColor::PFXFRandomColor(OSL_COLOR color)
{
	m_colors=new vector<OSL_COLOR>();
	m_colors->push_back(color);
}

PFXFRandomColor *PFXFRandomColor::clone() const
{
	PFXFRandomColor *theclone=new PFXFRandomColor(m_colors->at(0));
	
	for(unsigned int i=0;i<m_colors->size();i++)
	{
		theclone->addColor(m_colors->at(i));
	}
	
	return theclone;
}

PFXFRandomColor::~PFXFRandomColor()
{
	//debug("PFXFRandomColor : delete m_colors...");
	delete m_colors;
	//debug("PFXFRandomColor : end deletes");
}

AbstractGlobalEffect *PFXFRandomColor::newGlobalEffectInstance(int startX, int startY, int dist, int movingTime, int orientation, int scale, int particleLifespan)
{
	int color=m_colors->at(random(0,m_colors->size()-1));
	return new ProgressiveTintEffect(1, 1, color, color, 1);
}

void PFXFRandomColor::addColor(OSL_COLOR color)
{
	m_colors->push_back(color);
}

void PFXFRandomColor::replaceColorNumber(unsigned int number, OSL_COLOR color)
{
	if(number>=m_colors->size())
		return;
	
	m_colors->at(number)=color;
}































