#include "code/framework/particles/complete/fxFactories/PFXFRandomGravity.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/utils.h"


PFXFRandomGravity::PFXFRandomGravity()
{
	m_speedX_min=0.0f;
	m_speedX_max=0.0f;
	m_speedY_min=0.0f;
	m_speedY_max=0.0f;
	m_accelX_min=0.0f;
	m_accelX_max=0.0f;
	m_accelY_min=0.0f;
	m_accelY_max=0.0f;
}

PFXFRandomGravity *PFXFRandomGravity::clone() const
{
	PFXFRandomGravity *theclone=new PFXFRandomGravity();
	
	theclone->setSpeedXMin(m_speedX_min);
	theclone->setSpeedXMax(m_speedX_max);
	theclone->setSpeedYMin(m_speedY_min);
	theclone->setSpeedYMax(m_speedY_max);
	theclone->setAccelXMin(m_accelX_min);
	theclone->setAccelXMax(m_accelX_max);
	theclone->setAccelYMin(m_accelY_min);
	theclone->setAccelYMax(m_accelY_max);
	
	return theclone;
}

PFXFRandomGravity::~PFXFRandomGravity()
{
	
}

AbstractLocalEffect *PFXFRandomGravity::newLocalEffectInstance(int startX, int startY, int dist, int movingTime, int orientation, int scale, int particleLifespan)
{
	float speedX=utils::randomf(m_speedX_min, m_speedX_max);
	float speedY=utils::randomf(m_speedY_min, m_speedY_max);
	float accelX=utils::randomf(m_accelX_min, m_accelX_max);
	float accelY=utils::randomf(m_accelY_min, m_accelY_max);
	
	GravityEffect *gravfx=new GravityEffect(speedX, speedY, accelX, accelY);
	
	return gravfx;
}

float PFXFRandomGravity::getSpeedXMin()
{
	return m_speedX_min;
}
float PFXFRandomGravity::getSpeedXMax()
{
	return m_speedX_max;
}
float PFXFRandomGravity::getSpeedYMin()
{
	return m_speedY_min;
}
float PFXFRandomGravity::getSpeedYMax()
{
	return m_speedY_max;
}
float PFXFRandomGravity::getAccelXMin()
{
	return m_accelX_min;
}
float PFXFRandomGravity::getAccelXMax()
{
	return m_accelX_max;
}
float PFXFRandomGravity::getAccelYMin()
{
	return m_accelY_min;
}
float PFXFRandomGravity::getAccelYMax()
{
	return m_accelY_max;
}

void PFXFRandomGravity::setSpeedXMin(float val)
{
	m_speedX_min=val;
}
void PFXFRandomGravity::setSpeedXMax(float val)
{
	m_speedX_max=val;
}
void PFXFRandomGravity::setSpeedYMin(float val)
{
	m_speedY_min=val;
}
void PFXFRandomGravity::setSpeedYMax(float val)
{
	m_speedY_max=val;
}
void PFXFRandomGravity::setAccelXMin(float val)
{
	m_accelX_min=val;
}
void PFXFRandomGravity::setAccelXMax(float val)
{
	m_accelX_max=val;
}
void PFXFRandomGravity::setAccelYMin(float val)
{
	m_accelY_min=val;
}
void PFXFRandomGravity::setAccelYMax(float val)
{
	m_accelY_max=val;
}

