#ifndef PFXFRANDOMGRAVITY_H_
#define PFXFRANDOMGRAVITY_H_

#include "code/framework/fx/EffectsLib.h"
#include "code/framework/particles/complete/fxFactories/abstract/AbstractLocalParticleEffectFactory.h"


class PFXFRandomGravity: public AbstractLocalParticleEffectFactory
{
	private:
		float m_speedX_min;
		float m_speedX_max;
		float m_speedY_min;
		float m_speedY_max;
		float m_accelX_min;
		float m_accelX_max;
		float m_accelY_min;
		float m_accelY_max;
	
	public:
		PFXFRandomGravity();
		~PFXFRandomGravity();
		AbstractLocalEffect *newLocalEffectInstance(int startX, int startY, int dist, int movingTime, int orientation, int scale, int particleLifespan);
		float getSpeedXMin();
		float getSpeedXMax();
		float getSpeedYMin();
		float getSpeedYMax();
		float getAccelXMin();
		float getAccelXMax();
		float getAccelYMin();
		float getAccelYMax();
		
		void setSpeedXMin(float val);
		void setSpeedXMax(float val);
		void setSpeedYMin(float val);
		void setSpeedYMax(float val);
		void setAccelXMin(float val);
		void setAccelXMax(float val);
		void setAccelYMin(float val);
		void setAccelYMax(float val);
		
		PFXFRandomGravity *clone() const;
};

#endif /*PFXFRANDOMGRAVITY_H_*/
