#include "code/framework/particles/complete/fxFactories/PFXFRandomProportionMultiTint.h"
#include "code/framework/fx/EffectsLib.h"

#include "code/framework/utils.h"
using namespace utils;

PFXFRandomProportionMultiTint::PFXFRandomProportionMultiTint(int totalTime, int minimumTime)
{
	m_nbColors=0;
	m_minimumTime=minimumTime;
	m_totalTime=totalTime;
}

PFXFRandomProportionMultiTint *PFXFRandomProportionMultiTint::clone() const
{
	PFXFRandomProportionMultiTint *theclone=new PFXFRandomProportionMultiTint(m_totalTime, m_minimumTime);
	for(unsigned int i=0;i<m_colors.size();i++)
	{
		theclone->addColor(m_colors[i]);
	}
	return theclone;
}

PFXFRandomProportionMultiTint::~PFXFRandomProportionMultiTint()
{
	
}

void PFXFRandomProportionMultiTint::addColor(int color)
{
	m_colors.push_back(color);
	m_nbColors++;
}

AbstractGlobalEffect *PFXFRandomProportionMultiTint::newGlobalEffectInstance(int startX, int startY, int dist, int movingTime, int orientation, int scale, int particleLifespan)
{
	if(m_nbColors<2)
		oslFatalError("PFXFRandomProportionMultiTint : at least 2 colors required");
	
	float time_rest=m_totalTime;
	int nbTransitions=m_nbColors-1;
	float transition_rest=nbTransitions;
	
	SerialGlobalEffect *fx=new SerialGlobalEffect(1);
	
	for(int i=1;i<=nbTransitions;i++)
	{
		if(i==nbTransitions) //derniere transition
		{
			fx->addEffect(
				new ProgressiveTintEffect(int(time_rest), int(time_rest), m_colors[m_nbColors-2], m_colors[m_nbColors-1], 1)
			);
		}
		else //transition non derniere
		{
			int timeMin=m_minimumTime;
			int timeMax=int(   2*(time_rest/(transition_rest))   );
			if(i==nbTransitions-1) //avant derniere, faut s'assurer que la derniere a au moins le minimum
			{
				timeMax-=m_minimumTime;
			}
			int time=random(timeMin, timeMax);
			
			fx->addEffect(
				new ProgressiveTintEffect(time, time, m_colors[i-1], m_colors[i], 1)
			);
			
			time_rest-=time;
			transition_rest--;
		}
	}
	
	return fx;
}

















