#include "code/framework/particles/complete/fxFactories/PFXFRandomTranslation.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/utils.h"

PFXFRandomTranslation::PFXFRandomTranslation(int distMin, int distMax)
{
	m_distMin=distMin;
	m_distMax=distMax;
}

PFXFRandomTranslation *PFXFRandomTranslation::clone() const
{
	return new PFXFRandomTranslation(m_distMin, m_distMax);
}

PFXFRandomTranslation::~PFXFRandomTranslation()
{
	
}

AbstractLocalEffect *PFXFRandomTranslation::newLocalEffectInstance(int startX, int startY, int dist, int movingTime, int orientation, int scale, int particleLifespan)
{
	int rdist=utils::random(m_distMin, m_distMax);
	
	//point d'arrivee
	int targetY=oslSini(-orientation, rdist) + startY;
	int targetX=oslCosi(-orientation, rdist) + startX;
	
	TranslationEffect *fx_transl=new TranslationEffect(startX, startY, targetX, targetY, movingTime, movingTime, true, 1);
	return fx_transl;
}
	
int PFXFRandomTranslation::getDistMin()
{
	return m_distMin;
}

void PFXFRandomTranslation::setDistMin(int dist)
{
	m_distMin=dist;
}

int PFXFRandomTranslation::getDistMax()
{
	return m_distMax;
}

void PFXFRandomTranslation::setDistMax(int dist)
{
	m_distMax=dist;
}













