#include "code/framework/particles/complete/fxFactories/PFXFSimpleTranslation.h"
#include "code/framework/fx/EffectsLib.h"

PFXFSimpleTranslation::PFXFSimpleTranslation(int angleShift)
{
	m_angleShift=angleShift;
}

PFXFSimpleTranslation *PFXFSimpleTranslation::clone() const
{
	return new PFXFSimpleTranslation(m_angleShift);
}


PFXFSimpleTranslation::~PFXFSimpleTranslation()
{
	
}

AbstractLocalEffect *PFXFSimpleTranslation::newLocalEffectInstance(int startX, int startY, int dist, int movingTime, int orientation, int scale, int particleLifespan)
{
	//point d'arrivee
	int targetY=oslSini(-orientation-m_angleShift, dist) + startY;
	int targetX=oslCosi(-orientation-m_angleShift, dist) + startX;
	
	TranslationEffect *fx_transl=new TranslationEffect(startX, startY, targetX, targetY, movingTime, movingTime, true, 1);
	return fx_transl;
}
	
void PFXFSimpleTranslation::setAngleShift(int shift)
{
	m_angleShift=shift;
}













