#include "code/framework/time/Repeater.h"

Repeater::Repeater(int duration, int times)
{
	m_running=false;
	m_currentframe=0;
	m_currentloop=1;
	m_maxloops=times;
	m_frameduration=duration;
}

Repeater::~Repeater()
{
	
}

void Repeater::setDuration(int duration)
{
	m_frameduration=duration;
}

int Repeater::getDuration()
{
	return m_frameduration;
}

void Repeater::update()
{
	if(m_running)
	{
		if(m_currentframe<m_frameduration-1)
		{
			m_currentframe++;
		}
		else
		{
			if(m_maxloops==-1 || m_currentloop<m_maxloops)
			{
				m_currentframe=0;
				m_currentloop++;
			}
			else
			{
				m_running=false;
				m_currentframe++; //on depasse pour eviter que isevent ne renvoie toujours vrai
			}				
		}
	}
}

bool Repeater::finished()
{
	return m_currentframe>=m_frameduration;
}

bool Repeater::isEvent()
{
	return m_currentframe==m_frameduration-1;
}

void Repeater::start()
{
	m_running=true;
}
void Repeater::stop()
{
	m_running=false;
}
void Repeater::reset()
{
	m_currentframe=0;
	m_currentloop=1;
}
void Repeater::restart()
{
	reset();
	start();
}
bool Repeater::isRunning()
{
	return m_running;
}
 



