#ifndef REPEATER_H_
#define REPEATER_H_

#include "code/framework/interfaces/Playable.h"

class Repeater : public Playable
{
	private:
		bool m_running;
		int m_currentframe;
		int m_currentloop;
		int m_maxloops;
		int m_frameduration;
		
	
	public:
		Repeater(int duration, int times=-1);
		~Repeater();
		bool isEvent();
		bool finished();
		void setDuration(int duration);
		int getDuration();
		
		//Playable
		void update();
		void start();
		void stop();
		void reset();
		void restart();
		bool isRunning(); 
};

#endif /*REPEATER_H_*/
