#ifndef EVENTSSCENARIO_H_
#define EVENTSSCENARIO_H_
#include <list>
#include <string>
#include <map>
#include "code/framework/time/Timer.h"
using namespace std;

//retourne une liste de message informant des évènements a un instant t
class EventsScenario
{
	private:
		list<int> *m_currentEvents; //utilisé comme valeur de retour
		multimap<long int, int> *m_events;
		bool m_running;
		Timer *m_timer;
		long int m_lastUpdate;
				
	public:
		//EventsScenario(); //empty scenario
		EventsScenario(string configFile);
		~EventsScenario();
		list<int> *getCurrentEvents();
		void update(); //va chercher les evenements dans la map et les met dans la liste
		bool hasEvent(int eventNum); //dit si l'évènement eventNum est actif à cet instant
		
		void start();
		void pause();
		void reset();
		void restart();
		
		bool isRunning();
		double getTime(); //for debug
};

#endif /*EVENTSSCENARIO_H_*/
