#include "code/game/GamePref.h"
#include <map>
#include <string>
#include "code/framework/utils.h"

#include <oslib/oslib.h>
#include <fstream>

using namespace utils;
using namespace std;

map<string, string> *GamePref::preferences=new map<string, string>();



void GamePref::load(string filename)
{
	ifstream preffile(filename.c_str());
	
	if(preffile.fail())
		fatalError("GamePref::load : cannot open file " + filename);
	
	string line;
	while(getline(preffile,line))
	{
		if(line.find("[")!=0 && line.find("#")!=0 && line.find("//")!=0) //ne pas prendre les commentaires en compte
		{
			if(line.size()>2) //ne pas prendre en compte les lignes vides, au minimum "a=b"
			{
				int indice=line.find("=");
				string key=line.substr(0, indice); //longueur = indice
				string value=line.substr(indice+1, line.size()-1-indice);
				
				value=deleteAll(value, "\r");
				setValue(key, value);
			}
		}
	}
	preffile.close();
}

void GamePref::save(string filename)
{
	ofstream outfile (filename.c_str(), ios_base::trunc | ios_base::out);
	
	map<string,string>::iterator it;
	for(it=preferences->begin() ; it!=preferences->end(); it++)
	{
    	string key=(*it).first;
    	string value=(*it).second;
    	outfile << key << "=" << value << endl;
	}
	
	outfile.close();
}

string GamePref::getStrValue(string key)
{
	map<string,string>::iterator it=preferences->find(key);
	if(it!=preferences->end())
	{
		return (*it).second;
	}
	return string("");
}

int GamePref::getIntValue(string key)
{
	map<string,string>::iterator it=preferences->find(key);
	if(it!=preferences->end())
	{
		string res=it->second;
		return toInt(res);
	}
	return -1;
}

void GamePref::setValue(string key, string value)
{
	(*preferences)[key]=value;
}

void GamePref::setValue(string key, int value)
{
	(*preferences)[key]=toString(value);
}









