#ifndef SONGBANNER_H_
#define SONGBANNER_H_

#include <string>
#include <oslib/oslib.h>
//#include <vector>
#include "code/framework/bmpFont/BmpFont.h"
#include "code/framework/bmpFont/BmpText.h"
#include "code/framework/fx/EffectsLib.h"

using namespace std;

#define SONGBANNER_STAGE_COMING 0
#define SONGBANNER_STAGE_WAITING 1
#define SONGBANNER_STAGE_SHRINK 2
#define SONGBANNER_STAGE_GROW 3
#define SONGBANNER_STAGE_GO 4

//pour faire défiler le nom des chansons etc
class SongBanner
{
	private:
		int m_y; //sa position sur l'axe des y
		TranslationEffect *m_fx_transl_come; //effet d'arrivée du texte
		SizeWowEffect *m_fx_shrink; //entre 2 textes, ca rapetisse
		SizeWowEffect *m_fx_grow; //puis grandit
		TranslationEffect *m_fx_transl_go; //au dernier texte il repart
		WaitLocalEffect *m_fx_wait;
		
		OSL_IMAGE *m_txt_italic_begin; //1er texte doit etre en italique
		OSL_IMAGE *m_txt_italic_end; //dernier texte aussi
		OSL_IMAGE **m_txt; //tableau de pointeurs vers les textes
		
		int m_nbtxt; //nombre de textes dispo
		
		int m_stage; //etape
		int m_currenttxt;
		bool m_finished;
		
		void setImageLeftCenter(OSL_IMAGE *img);
		
		int m_totalTimePresent;
		
		OSL_IMAGE *m_bg;
	
	public:
		SongBanner(int y, string fontfolder, string fontname, string fontnameitalic, string line1, string line2="", string line3="", string line4="");
		~SongBanner();
		
		void draw();
		void update();
		void reset();
		
		int getTotalTimePresent();
		void setBgImage(OSL_IMAGE *bg);
};

#endif /*SONGBANNER_H_*/
