#ifndef METEOR_H_
#define METEOR_H_

#include "code/framework/State.h"
#include <oslib/oslib.h>
#include "code/game/levels/utils/DJMCOContentLayered.h"
#include "code/framework/particles/complete/abstract/AbstractParticleGenerator.h"
#include "code/framework/interfaces/Drawable.h"
#include "code/framework/interfaces/Playable.h"
#include "code/framework/interfaces/Positionable.h"
#include "code/framework/time/repeater.h"
#include "code/framework/State.h"
#include "code/framework/fx/EffectsLib.h"

class Meteor : public Drawable, public Playable, public Positionable
{
	private:
		DJMCOContentLayered *m_mco;
		AbstractParticleGenerator *m_partgen;
		int m_x, m_y;
		Repeater *m_repeater;
		State *m_state;
		int m_partgen_shift_y;
	
	public:
		Meteor(DJMCOContentLayered *mco, AbstractParticleGenerator *partgen, int partgen_shift_y);
		~Meteor();
				
		AbstractParticleGenerator *getGenerator();
		bool finished();
		void update(AbstractLocalEffect *fx_trans);
		
		//drawable
		void draw(AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		
		//playable
		void update();
		void start();
		void stop();
		void reset();
		void restart();
		bool isRunning();
		
		//positionable
		void setX(int x);
		void setY(int y);
		int getX();
		int getY();
		
		//statesaveable
		State *savestate(State * state);
		void restorestate(State * state);
		
};

#endif /*METEOR_H_*/
