#include "code/game/levels/impl/projectsexy/SexyMCOContentParticles.h"
#include "code/framework/particles/complete/fx/ParticlesProgressiveTintEffect.h"
#include "code/game/gamedef.h"

SexyMCOContentParticles::SexyMCOContentParticles(int particles, int frames, int time, int distance, int colorFrom, int colorTo, MCOContentSimple *mcocontentsimple)
{
	//m_gen=new ParticleGeneratorPoint(0, 0, 90, 60, particles, frames, time, distance, time, "res/levels/projectsexy/particle.png", OSL_PF_4444, -1);
	m_gen=new ParticleGeneratorSegment(0, 0, 90, GAMEDEF_PIECE_WIDTH-4, particles, frames, time, distance, time, "res/levels/projectsexy/pieces/particles/particle.png", OSL_PF_8888);
	m_gen->setLocalEffect1SimpleTranslation();
	m_gen->setGlobalEffect1(new ParticlesProgressiveTintEffect(time, 0, colorFrom, colorTo, 1));
	m_gen->start();
	m_gen->generationOn();
	
	m_mcocontentsimple=mcocontentsimple;
}

SexyMCOContentParticles::~SexyMCOContentParticles()
{
	delete m_gen;
	delete m_mcocontentsimple;
}

//drawable
void SexyMCOContentParticles::draw(AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	m_gen->draw();
	m_mcocontentsimple->draw(fx1, fx2, fx3, fx4, fx5);
}

void SexyMCOContentParticles::drawXY(int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	m_gen->drawXY(x, y);
	m_mcocontentsimple->drawXY(x, y, fx1, fx2, fx3, fx4, fx5);
}

//playable
/*
void SexyMCOContentParticles::update()
{
	m_gen->update(NULL);
	m_mcocontentsimple->update();
}*/

void SexyMCOContentParticles::update()
{
	//AbstractEffectOnPositionable *fx=(AbstractEffectOnPositionable *)fx_trans;
	m_gen->update();
	m_mcocontentsimple->update();
}

void SexyMCOContentParticles::start()
{
	m_gen->generationOff();
	m_mcocontentsimple->start();
}

void SexyMCOContentParticles::stop()
{
	
}

void SexyMCOContentParticles::reset()
{
	
}

void SexyMCOContentParticles::restart()
{
	
}

bool SexyMCOContentParticles::isRunning()
{
	return m_mcocontentsimple->isRunning();
}


//positionable
void SexyMCOContentParticles::setX(int x)
{
	m_gen->setX(x);
	m_mcocontentsimple->setX(x);
}

void SexyMCOContentParticles::setY(int y)
{
	m_gen->setY(y+GAMEDEF_PIECE_HEIGHT/2);
	m_mcocontentsimple->setY(y);
}

int SexyMCOContentParticles::getX()
{
	//return m_gen->getX();
	return m_mcocontentsimple->getX();
}

int SexyMCOContentParticles::getY()
{
//	return m_gen->getY()-GAMEDEF_PIECE_HEIGHT/2;
	return m_mcocontentsimple->getY();
}

State *SexyMCOContentParticles::savestate(State * state)
{
	return m_gen->savestate(state);
}

void SexyMCOContentParticles::restorestate(State * state)
{
	m_gen->restorestate(state);
}

int SexyMCOContentParticles::specialEvent(int event)
{
	if(event==LEVEL_SEXY_MCO_EVENT_GETNBPARTICLES)
	{
		return m_gen->getCurrentNbParticles();
	}
	return 0;
}
