#include "code/game/levels/impl/underwater/CondemnedParticleGeneratorPoint.h"

CondemnedParticleGeneratorPoint::CondemnedParticleGeneratorPoint(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, 
							int dist, int particleLifespan, AbstractAnimationFactory *animFactory, int nbLoops)
:ParticleGeneratorPoint(x, y, direction, scale, nbParticles, generationTime, movingTime, dist, particleLifespan, animFactory, nbLoops)
,CondemnedObject(false)						
{
	
}

CondemnedParticleGeneratorPoint::CondemnedParticleGeneratorPoint(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, int dist, 
						int particleLifespan, Anim *anim, int nbLoops)
:ParticleGeneratorPoint(x, y, direction, scale, nbParticles, generationTime, movingTime, dist, particleLifespan, anim, nbLoops)
,CondemnedObject(false)
{
	
}

CondemnedParticleGeneratorPoint::CondemnedParticleGeneratorPoint(	int x, int y, int direction, int scale, int nbParticles, int generationTime, int movingTime, int dist,
						int particleLifespan, string filename, short transparency, int nbLoops)
:ParticleGeneratorPoint(x, y, direction, scale, nbParticles, generationTime, movingTime, dist, particleLifespan, filename, transparency, nbLoops)						
,CondemnedObject(false)
{
	
}

CondemnedParticleGeneratorPoint *CondemnedParticleGeneratorPoint::clone() const
{
	CondemnedParticleGeneratorPoint *theclone = new CondemnedParticleGeneratorPoint(
		m_x, m_y, m_orientation, m_scale, 
		getThroughputNbParticles(), getThroughputFrameTime(), m_movingTime, 
		m_dist, m_particleLifespan, getAnimationFactory()->clone(), getNbLoops()
	);
	
	
	if(m_lfx1!=NULL)
		theclone->setLocalEffect1(m_lfx1->clone());
	if(m_lfx2!=NULL)
		theclone->setLocalEffect2(m_lfx2->clone());
	if(m_lfx3!=NULL)
		theclone->setLocalEffect3(m_lfx3->clone());
	if(m_lfx4!=NULL)
		theclone->setLocalEffect4(m_lfx4->clone());
	if(m_lfx5!=NULL)
		theclone->setLocalEffect5(m_lfx5->clone());
	if(m_gfx1!=NULL)
		theclone->setGlobalEffect1(m_gfx1->clone());
	if(m_gfx2!=NULL)
		theclone->setGlobalEffect2(m_gfx2->clone());
	
	/*if(isCondemned)
		theclone->setCondemned(true);*/
			
	return theclone;
}

CondemnedParticleGeneratorPoint::~CondemnedParticleGeneratorPoint()
{
	
}

bool CondemnedParticleGeneratorPoint::mustBeDestroyed()
{
	return isCondemned() && getCurrentNbParticles()==0;
}

