#include "code/game/levels/impl/underwater/MCOContentComboBubbles.h"
#include "code/framework/utils.h"

using namespace utils;

MCOContentComboBubbles::MCOContentComboBubbles(MCOContentCombo *mcocc, CondemnedParticleGeneratorPoint* bubbles_constant, CondemnedParticleGeneratorPoint* bubbles_combos, CondemnedParticleGeneratorPoint* bubbles_explode)
{
	m_mcoc_combo=mcocc;
	m_gen_bubbles_constant=bubbles_constant;
	m_gen_bubbles_combos=bubbles_combos;
	m_gen_bubbles_explode=bubbles_explode;
	
	m_gen_bubbles_constant->start();
}

MCOContentComboBubbles::~MCOContentComboBubbles()
{
	delete m_mcoc_combo;
	m_gen_bubbles_constant->setCondemned(true);
	m_gen_bubbles_combos->setCondemned(true);
	m_gen_bubbles_explode->setCondemned(true);
}

int MCOContentComboBubbles::specialEvent(int event)
{
	//TODO: tester events speciaux et return 0
	//else
	if(event==MCOCONTENT_EVENT_EXPLODE)
	{
		m_gen_bubbles_explode->start();
		m_gen_bubbles_constant->generationOff();
//		if(!m_mcoc_combo->isRunning())
//			m_justexploded=true;
	}
	else if(event==MCOCONTENT_EVENT_COMBO_DECREMENT)
	{
		m_gen_bubbles_combos->gotoStart();
		m_gen_bubbles_combos->start();
	}

	return m_mcoc_combo->specialEvent(event);
}
		
//drawable
void MCOContentComboBubbles::draw(AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	m_gen_bubbles_constant->draw(fx1, fx2, fx3, fx4, fx5);
	m_gen_bubbles_combos->draw(fx1, fx2, fx3, fx4, fx5);
	m_gen_bubbles_explode->draw(fx1, fx2, fx3, fx4, fx5);
	m_mcoc_combo->draw(fx1, fx2, fx3, fx4, fx5);
}

void MCOContentComboBubbles::drawXY(int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	m_gen_bubbles_constant->drawXY(x, y, fx1, fx2, fx3, fx4, fx5);
	m_gen_bubbles_combos->drawXY(x, y, fx1, fx2, fx3, fx4, fx5);
	m_gen_bubbles_explode->drawXY(x, y, fx1, fx2, fx3, fx4, fx5);
	m_mcoc_combo->drawXY(x, y, fx1, fx2, fx3, fx4, fx5);
}

//playable
void MCOContentComboBubbles::update()
{
	m_mcoc_combo->update();
	m_gen_bubbles_constant->update();
	m_gen_bubbles_combos->update();
	m_gen_bubbles_explode->update();
}

void MCOContentComboBubbles::start()
{
//	if(!m_mcoc_combo->isRunning())
//		m_justexploded=true;
	m_mcoc_combo->start();
	m_gen_bubbles_explode->start();
	m_gen_bubbles_constant->generationOff();
	
}

void MCOContentComboBubbles::stop()
{
	m_mcoc_combo->stop();
	m_gen_bubbles_constant->stop();
	m_gen_bubbles_combos->stop();
	m_gen_bubbles_explode->stop();
}

void MCOContentComboBubbles::reset()
{
	m_mcoc_combo->reset();
	m_gen_bubbles_constant->reset();
	m_gen_bubbles_combos->reset();
	m_gen_bubbles_explode->reset();
}

void MCOContentComboBubbles::restart()
{
	m_mcoc_combo->restart();
	m_gen_bubbles_constant->restart();
	m_gen_bubbles_combos->restart();
	m_gen_bubbles_explode->restart();
}
bool MCOContentComboBubbles::isRunning()
{
	return m_mcoc_combo->isRunning();
}


//positionable
void MCOContentComboBubbles::setX(int x)
{
	m_mcoc_combo->setX(x);
	m_gen_bubbles_constant->setX(x);
	m_gen_bubbles_combos->setX(x);
	m_gen_bubbles_explode->setX(x);
}
void MCOContentComboBubbles::setY(int y)
{
	m_mcoc_combo->setY(y);
	m_gen_bubbles_constant->setY(y);
	m_gen_bubbles_combos->setY(y);
	m_gen_bubbles_explode->setY(y);
}

int MCOContentComboBubbles::getX()
{
	return m_mcoc_combo->getX();
}

int MCOContentComboBubbles::getY()
{
	return m_mcoc_combo->getY();
}

//statesaveable
State *MCOContentComboBubbles::savestate(State * state)
{
	return m_gen_bubbles_constant->savestate(state);
}

void MCOContentComboBubbles::restorestate(State * state)
{
	m_mcoc_combo->restorestate(state);
	m_gen_bubbles_constant->restorestate(state);
	m_gen_bubbles_combos->restorestate(state);
	m_gen_bubbles_explode->restorestate(state);
}




