#include "code/game/levels/impl/underwater/fauna/Animal.h"
#include <oslib/oslib.h>

Animal::Animal(Anim *animclone, TranslationEffect *translationfx, int sizereduction, bool direction)
{
	m_anim=animclone;
	m_direction=direction;
	m_fx_translation=translationfx;
	m_fx_translation->start();
	m_anim->start();
	m_fx_size=new SizeWowEffect(sizereduction, 0,sizereduction, 0, 1, 1);
	//pas de start sur m_fx_size, le poisson se prend juste la reduction de base
}

Animal::~Animal()
{
	delete m_anim;
	delete m_fx_translation;
	delete m_fx_size;
}


void Animal::drawRelative(int watery)
{
	if(!m_direction)
	{
		oslMirrorImageH(m_anim->getImage());
	}
	fx::drawXY(m_anim->getImage(), 0, watery, m_fx_translation, m_fx_size);
	if(!m_direction)
	{
		oslMirrorImageH(m_anim->getImage());
	}
}

void Animal::update()
{
	m_fx_translation->update();
	m_anim->update();
}

bool Animal::finished()
{
	return m_fx_translation->finished();
}
