#include "code/game/levels/impl/underwater/fauna/AnimalProperties.h"

AnimalProperties::AnimalProperties(int xleft, int xright, int ymin, int ymax, int translmin, int translmax, Anim *animref, int spawnproportion, int sizemin)
{
	//suivant la taille il doit commencer + ou - loin du bord
	m_x_left=xleft;
	m_x_right=xright;
	
	//la profondeur min et max ou il a le droit d'apparaitre
	//c'est la distance avec la surface
	m_y_min=ymin;
	m_y_max=ymax;
	
	//vitesse de déplacement
	m_transl_time_min=translmin;
	m_transl_time_max=translmax;
	
	m_anim=animref;
	
	m_spawn_proportion=spawnproportion;
	
	m_size_minimum_percent=sizemin;
}

AnimalProperties::~AnimalProperties()
{
	delete m_anim;
}

int AnimalProperties::getMaxReductionPercent()
{
	return m_size_minimum_percent;
}

int AnimalProperties::getXLeft()
{
	return m_x_left;
}

int AnimalProperties::getXRight()
{
	return m_x_right;
}

int AnimalProperties::getYMin()
{
	return m_y_min;
}

int AnimalProperties::getYMax()
{
	return m_y_max;
}

int AnimalProperties::getTranslationTimeMin()
{
	return m_transl_time_min;
}

int AnimalProperties::getTranslationTimeMax()
{
	return m_transl_time_max;
}

Anim *AnimalProperties::getAnimClone()
{
	return new Anim(*m_anim);
}

int AnimalProperties::getSpawnProportion()
{
	return m_spawn_proportion;
}








