#include "code/game/levels/utils/DJMCOContentSimple.h"
#include "code/framework/fx/EffectsLib.h"
#include <oslib/oslib.h>

DJMCOContentSimple::DJMCOContentSimple(Anim *aclone, OSL_COLOR color)
{
	m_anim=aclone;
	m_color=color;
	
	m_color_comp=new int[4];
	oslRgbaGet8888(m_color, m_color_comp[0], m_color_comp[1], m_color_comp[2], m_color_comp[3]);
	m_alpha = new OSL_ALPHA_PARAMS;
	m_curColor=new u8[4];
	m_newColor=new u8[4];
}

DJMCOContentSimple::~DJMCOContentSimple()
{
	delete m_anim;
	
	delete[] m_color_comp;
	delete m_alpha;
	delete[] m_curColor;
	delete[] m_newColor;
}

Anim *DJMCOContentSimple::getAnim()
{
	return m_anim;
}

OSL_COLOR DJMCOContentSimple::getColor()
{
	return m_color;
}

void DJMCOContentSimple::setColor(OSL_COLOR color)
{
	m_color=color;
	oslRgbaGet8888(m_color, m_color_comp[0], m_color_comp[1], m_color_comp[2], m_color_comp[3]);
}

//drawable
void DJMCOContentSimple::draw(AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	oslGetAlphaEx(m_alpha);
	oslRgbaGet8888(m_alpha->coeff1, m_curColor[0], m_curColor[1], m_curColor[2], m_curColor[3]);
	m_alpha->effect=OSL_FX_ALPHA | OSL_FX_TINT;
	for(int i=0;i<4;i++)
	{	
		m_newColor[i]=u8(float(m_curColor[i]*m_color_comp[i])/255.0f);
	}
	int oldcoeff1=m_alpha->coeff1;
	m_alpha->coeff1=RGBA(m_newColor[0], m_newColor[1], m_newColor[2], m_newColor[3]);
	oslSetAlphaEx(m_alpha);
	
	//on dessine
	fx::drawXY(m_anim->getImage(), m_anim->getX(), m_anim->getY(), fx1,fx2,fx3,fx4,fx5);
	
	//on remet comme avant
	m_alpha->coeff1=oldcoeff1;
	oslSetAlphaEx(m_alpha);
}

void DJMCOContentSimple::drawXY(int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	oslGetAlphaEx(m_alpha);
	oslRgbaGet8888(m_alpha->coeff1, m_curColor[0], m_curColor[1], m_curColor[2], m_curColor[3]);
	m_alpha->effect=OSL_FX_ALPHA | OSL_FX_TINT;
	for(int i=0;i<4;i++)
	{	
		m_newColor[i]=u8(float(m_curColor[i]*m_color_comp[i])/255.0f);
	}
	int oldcoeff1=m_alpha->coeff1;
	m_alpha->coeff1=RGBA(m_newColor[0], m_newColor[1], m_newColor[2], m_newColor[3]);
	oslSetAlphaEx(m_alpha);
	
	//on dessine
	fx::drawXY(m_anim->getImage(),x,y,fx1,fx2,fx3,fx4,fx5);
	
	//on remet comme avant
	m_alpha->coeff1=oldcoeff1;
	oslSetAlphaEx(m_alpha);
}

//playable
void DJMCOContentSimple::update()
{
	m_anim->update();
}

void DJMCOContentSimple::start()
{
	m_anim->start();
}

void DJMCOContentSimple::stop()
{
	m_anim->stop();
}

void DJMCOContentSimple::reset()
{
	m_anim->reset();
}

void DJMCOContentSimple::restart()
{
	m_anim->restart();
}

bool DJMCOContentSimple::isRunning()
{
	return m_anim->isRunning();
}


//positionable
void DJMCOContentSimple::setX(int x)
{
	m_anim->setX(x);
}

void DJMCOContentSimple::setY(int y)
{
	m_anim->setY(y);
}

int DJMCOContentSimple::getX()
{
	return m_anim->getX();
}

int DJMCOContentSimple::getY()
{
	return m_anim->getY();
}

State *DJMCOContentSimple::savestate(State * state)
{
	return m_anim->savestate(state);
}

void DJMCOContentSimple::restorestate(State * state)
{
	m_anim->restorestate(state);
}

int DJMCOContentSimple::specialEvent(int event)
{
	return 0;
}
