#include "code/game/levels/utils/MCOContentSimple.h"
#include "code/framework/fx/EffectsLib.h"

MCOContentSimple::MCOContentSimple(Anim *aclone)
{
	m_anim=aclone;
}

MCOContentSimple::~MCOContentSimple()
{
	delete m_anim;
}

Anim *MCOContentSimple::getAnim()
{
	return m_anim;
}

//drawable
void MCOContentSimple::draw(AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	fx::drawXY(m_anim->getImage(), m_anim->getX(), m_anim->getY(), fx1,fx2,fx3,fx4,fx5);
}

void MCOContentSimple::drawXY(int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	fx::drawXY(m_anim->getImage(),x,y,fx1,fx2,fx3,fx4,fx5);
}

//playable
void MCOContentSimple::update()
{
	m_anim->update();
}

void MCOContentSimple::start()
{
	m_anim->start();
}

void MCOContentSimple::stop()
{
	m_anim->stop();
}

void MCOContentSimple::reset()
{
	m_anim->reset();
}

void MCOContentSimple::restart()
{
	m_anim->restart();
}

bool MCOContentSimple::isRunning()
{
	return m_anim->isRunning();
}


//positionable
void MCOContentSimple::setX(int x)
{
	m_anim->setX(x);
}

void MCOContentSimple::setY(int y)
{
	m_anim->setY(y);
}

int MCOContentSimple::getX()
{
	return m_anim->getX();
}

int MCOContentSimple::getY()
{
	return m_anim->getY();
}

State *MCOContentSimple::savestate(State * state)
{
	return m_anim->savestate(state);
}

void MCOContentSimple::restorestate(State * state)
{
	m_anim->restorestate(state);
}

int MCOContentSimple::specialEvent(int event)
{
	return 0;
}
