#include "code/game/loading/LoadingRes.h"
#include "code/game/gamedef.h"
#include "code/framework/utils.h"
#include "code/framework/check/loaders.h"

using namespace utils;

LoadingRes::LoadingRes()
{
	m_timer=new Timer();
	m_timer->start();
	//m_img_screencpy=oslCreateSwizzledImage(oslGetDrawBuffer(),OSL_IN_RAM);
	/*m_img_screencpy=oslCreateImage (480, 272, OSL_IN_RAM|OSL_SWIZZLED, OSL_SECONDARY_BUFFER->pixelFormat);
	oslClearImage(m_img_screencpy, RGBA(0,0,0,255));
	oslLockImage (OSL_SECONDARY_BUFFER);
	utils::drawImageOnImage(OSL_SECONDARY_BUFFER, 0, 0, 480, 272, m_img_screencpy, 0, 0);
	oslUnlockImage (OSL_SECONDARY_BUFFER);
	*/
	m_img_screencpy=getBufferCopy();
		
	//m_img_screencpy = oslConvertImageTo(m_img_screencpy, OSL_IN_RAM, OSL_PF_8888);
	//m_fx_trans=new TranslationEffect(0, 0, 480, -272, 60, 60, true, 1);
	m_fx_scrcpy_grav=new GravityEffect(11.8f, -6.0f, 0.0f, 0.65f);
	m_fx_scrcpy_shrink=new SizeWowEffect(95, 0, 95, 0, 40, 40, false, 1);
	
	m_img_bg=fwkLoadImageFilePNG("res/menus/loading/loading2.png", OSL_IN_RAM|OSL_SWIZZLED, OSL_PF_8888 /*GAMEDEF_SCREENMODE*/);
	m_img_vinyl=fwkLoadImageFilePNG("res/menus/loading/vinyl.png", OSL_IN_RAM | OSL_SWIZZLED, OSL_PF_5551);
	oslImageSetCenter(m_img_vinyl, 26, 25);
	m_img_djdrops=fwkLoadImageFilePNG("res/menus/loading/dj_dr_ps.png", OSL_IN_RAM | OSL_SWIZZLED, OSL_PF_5551);
	
	m_img_L=fwkLoadImageFilePNG("res/menus/loading/L.png", OSL_IN_RAM|OSL_SWIZZLED, OSL_PF_4444);
	oslSetImageRotCenter(m_img_L);
	m_img_o=fwkLoadImageFilePNG("res/menus/loading/o.png", OSL_IN_RAM|OSL_SWIZZLED, OSL_PF_4444);
	oslSetImageRotCenter(m_img_o);
	m_img_a=fwkLoadImageFilePNG("res/menus/loading/a.png", OSL_IN_RAM|OSL_SWIZZLED, OSL_PF_4444);
	oslSetImageRotCenter(m_img_a);
	m_img_d=fwkLoadImageFilePNG("res/menus/loading/d.png", OSL_IN_RAM|OSL_SWIZZLED, OSL_PF_4444);
	oslSetImageRotCenter(m_img_d);
	m_img_i=fwkLoadImageFilePNG("res/menus/loading/i.png", OSL_IN_RAM|OSL_SWIZZLED, OSL_PF_4444);
	oslSetImageRotCenter(m_img_i);
	m_img_n=fwkLoadImageFilePNG("res/menus/loading/n.png", OSL_IN_RAM|OSL_SWIZZLED, OSL_PF_4444);
	oslSetImageRotCenter(m_img_n);
	m_img_g=fwkLoadImageFilePNG("res/menus/loading/g.png", OSL_IN_RAM|OSL_SWIZZLED, OSL_PF_4444);
	oslSetImageRotCenter(m_img_g);
	
	m_fx_vinyl_rot=new RotationEffect(75);
	
	//tableau de couleurs pour un effet de teinte en ordre aleatoire
	u32 colors[6];
	colors[0]=RGB(255,0,0);
	colors[1]=RGB(255,0,255);
	colors[2]=RGB(0,0,255);
	colors[3]=RGB(0,255,255);
	colors[4]=RGB(0,255,0);
	colors[5]=RGB(255,255,0);
	
	int from=random(0,5); //1ere couleur affichée
	int to=(from+1)%6;
	m_fx_bg_tint = new SerialGlobalEffect();
	m_fx_bg_tint->addEffect(new ProgressiveTintEffect(40, 40, colors[from], colors[to], 1));
	from=to;
	to=(to+1)%6;
	m_fx_bg_tint->addEffect(new ProgressiveTintEffect(40, 40, colors[from], colors[to], 1));
	from=to;
	to=(to+1)%6;
	m_fx_bg_tint->addEffect(new ProgressiveTintEffect(40, 40, colors[from], colors[to], 1));
	from=to;
	to=(to+1)%6;
	m_fx_bg_tint->addEffect(new ProgressiveTintEffect(40, 40, colors[from], colors[to], 1));
	from=to;
	to=(to+1)%6;
	m_fx_bg_tint->addEffect(new ProgressiveTintEffect(40, 40, colors[from], colors[to], 1));
	from=to;
	to=(to+1)%6;
	m_fx_bg_tint->addEffect(new ProgressiveTintEffect(40, 40, colors[from], colors[to], 1));
	
	//effets sur les lettres
	//TODO: mettre plusieurs effets et choisir au hasard
	int shift=8;
	int grow=14;
	int shrink=12;
	int percent=65;
	
	m_fx_L=new SerialLocalEffect();
	m_fx_L->addEffect(new SizeWowEffect(0, percent, 0, percent, grow, shrink, true, 2));
	m_fx_L->addEffect(new WaitLocalEffect(shift*6));
	
	m_fx_o=new SerialLocalEffect();
	m_fx_o->addEffect(new WaitLocalEffect(shift));
	m_fx_o->addEffect(new SizeWowEffect(0, percent, 0, percent, grow, shrink, true, 2));
	m_fx_o->addEffect(new WaitLocalEffect(shift*5));
	
	m_fx_a=new SerialLocalEffect();
	m_fx_a->addEffect(new WaitLocalEffect(shift*2));
	m_fx_a->addEffect(new SizeWowEffect(0, percent, 0, percent, grow, shrink, true, 2));
	m_fx_a->addEffect(new WaitLocalEffect(shift*4));
	
	m_fx_d=new SerialLocalEffect();
	m_fx_d->addEffect(new WaitLocalEffect(shift*3));
	m_fx_d->addEffect(new SizeWowEffect(0, percent, 0, percent, grow, shrink, true, 2));
	m_fx_d->addEffect(new WaitLocalEffect(shift*3));
	
	m_fx_i=new SerialLocalEffect();
	m_fx_i->addEffect(new WaitLocalEffect(shift*4));
	m_fx_i->addEffect(new SizeWowEffect(0, percent, 0, percent, grow, shrink, true, 2));
	m_fx_i->addEffect(new WaitLocalEffect(shift*2));
	
	m_fx_n=new SerialLocalEffect();
	m_fx_n->addEffect(new WaitLocalEffect(shift*5));
	m_fx_n->addEffect(new SizeWowEffect(0, percent, 0, percent, grow, shrink, true, 2));
	m_fx_n->addEffect(new WaitLocalEffect(shift));
	
	m_fx_g=new SerialLocalEffect();
	m_fx_g->addEffect(new WaitLocalEffect(shift*6));
	m_fx_g->addEffect(new SizeWowEffect(0, percent, 0, percent, grow, shrink, true, 2));
	
	m_pws=new PleaseWaitSound(/*true*/);
}

LoadingRes::~LoadingRes()
{
	delete m_pws;
	oslDeleteImage(m_img_screencpy);
	//delete m_fx_trans;
	delete m_fx_scrcpy_grav;
	delete m_fx_scrcpy_shrink;
	
	oslDeleteImage(m_img_bg);
	oslDeleteImage(m_img_vinyl);
	oslDeleteImage(m_img_djdrops);
	oslDeleteImage(m_img_L);
	oslDeleteImage(m_img_o);
	oslDeleteImage(m_img_a);
	oslDeleteImage(m_img_d);
	oslDeleteImage(m_img_i);
	oslDeleteImage(m_img_n);
	oslDeleteImage(m_img_g);
	
	delete m_timer;
	
	delete m_fx_vinyl_rot;
	
	delete m_fx_bg_tint;
	
	delete m_fx_L;
	delete m_fx_o;
	delete m_fx_a;
	delete m_fx_d;
	delete m_fx_i;
	delete m_fx_n;
	delete m_fx_g;
}










