#ifndef LOGO_H_
#define LOGO_H_

#include <oslib/oslib.h>
#include "code/framework/particles/complete/impl/ParticleGeneratorPoint.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/time/Delayer.h"
#include "code/framework/time/Timer.h"

class Logo
{
	private:
		//test
		int m_test;
	
		//images
		OSL_IMAGE *m_img_excuse;
		OSL_IMAGE *m_img_wheel;
		OSL_IMAGE *m_img_bg;
		OSL_IMAGE *m_img_fade; //image toute noire
		OSL_IMAGE **m_img_daaa; //tableau d'images
		
		//générateur
		ParticleGeneratorPoint *m_partgen;
		int m_partgen_scale1;
		int m_partgen_scale2;
		
		//effets
		RotationEffect *m_fx_wheelrot;
		ProgressiveAlphaEffect *m_fx_fadein;
		ProgressiveAlphaEffect *m_fx_fadeout;
		SerialLocalEffect *m_fx_excuse_rotation; //penché durant déplacement, redressement, attente, remuage 
		TranslationEffect *m_fx_excuse_move; //déplacement
		Delayer *m_delayer_generator; 
		ProgressiveAlphaEffect *m_fx_daaa_fadein;
		SerialLocalEffect ** m_fx_daaa_transl; //tableau d'effets
		GravityEffect *m_fx_gravity;//uniquement le pointeur pour pouvoir le modifier
		
		OSL_SOUND *m_music;
		Delayer *m_delayer_music;
		Timer *m_timer_end;
		long int m_music_length;
				
		void drawScene();
		void keys();
		
		
	public:
		Logo();
		~Logo();
		
		void go();
		
};


#endif /*LOGO_H_*/
