#ifndef MENUITEMMANAGER_H_
#define MENUITEMMANAGER_H_
#include <vector>
#include <string>
#include "code/framework/menus/MenuItem.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/bmpFont/BmpFont.h"
#include "code/game/menus/MenusDefines.h"

#define MENUSTATE_WAIT 1
#define MENUSTATE_SELECTIONNING 2
#define MENUSTATE_GOINGUP 3
#define MENUSTATE_GOINGDOWN 4
#define MENUSTATE_CANCELING 5



using namespace std;

class MenuItemManager
{
	private:
		MenuItem * m_root;
		MenuItem * m_current;
		
		//etat
		//bool m_effectsRunning; //si true, les actions ne donnent rien car on est en transition
		
		//effets dont on a besoin pour les transitions:
		//VanishUpEffect *m_fx_vanishup; //l'item du haut disparait
		//AppearDownEffect *m_fx_appeardown; //le nouvel item apparait
		//translationeffect //les items du milieu et du bas montent
				
		RotationEffect *m_fx_rotation; //lors de la selection, l'item tourne
		SizeWowEffect *m_fx_grow; //lors de la selection, l'item grossi
		SerialGlobalEffect * m_fx_selection_disappear; //lors de la selection, l'item disparait
		ProgressiveAlphaEffect * m_fx_selection_otherDisappear;//lors de la selection, les autres items disparaissent
		
		SizeWowEffect *m_fx_highlight;
		
		SizeWowEffect *m_fx_cancel; //lors de l'annulation, les items rapetissent
		
		TranslationEffect *m_fx_down_translation; //lorsqu'on appuie sur bas, les items montent
		VanishUpEffect *m_fx_down_vanish; //lorsqu'on appuie sur bas, l'item du haut disparait.
		AppearDownEffect *m_fx_down_appear; //lorsqu'on appuie sur bas, l'item du dessous apparait
		
		TranslationEffect *m_fx_up_translation; //lorsqu'on appuie sur haut, les items descendent
		AppearUpEffect *m_fx_up_appear; //lorsqu'on appuie sur haut, l'item du dessus apparait
		VanishDownEffect *m_fx_up_vanish; //lorsqu'on appuie sur haut, l'item du bas disparait
		
		int m_state;//=MENUSTATE_WAIT;
		
		int m_distance;
		
	public:
		MenuItemManager();
		~MenuItemManager();
		void initAsMainMenu(string locale, BmpFont * f);
		void initAsTestMenu(string locale, BmpFont * f);
		void initAsDemoMenu(string locale, BmpFont * f);
		
		int selectAction();
		bool cancelAction();
		bool nextMenuAction();
		bool previousMenuAction();
		bool nextValueAction();
		bool previousValueAction();
		
		//TODO: //on dessine 3 items a la fois.
		//OSL_IMAGE getPrevious();
		//OSL_IMAGE getNext();
		//OSL_IMAGE getCurrent();
		
		int update(); //retourne une action a effectuer (apres que les anims aient fini).
		
		//test:
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL);
};

#endif /*MENUITEMMANAGER_H_*/








