#ifndef PDR4CMENUITEMMANAGER_H_
#define PDR4CMENUITEMMANAGER_H_
#include <vector>
#include <string>
#include "code/framework/menus/MenuItem.h"
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/bmpFont/BmpFont.h"
#include "code/game/menus/MenusDefines.h"

#define MENUSTATE_WAIT 1
#define MENUSTATE_SELECTIONNING 2
#define MENUSTATE_GOINGUP 3
#define MENUSTATE_GOINGDOWN 4
#define MENUSTATE_CANCELING 5



using namespace std;

class PDR4CMenuItemManager
{
	private:
		MenuItem * m_root;
		MenuItem * m_current;
											
		BlinkEffect *m_fx_blink; //lors de la selection, l'item clignote
				
		TranslationEffect *m_fx_down_translation; //lorsqu'on appuie sur bas, les items montent
		VanishUpEffect *m_fx_down_vanish; //lorsqu'on appuie sur bas, l'item du haut disparait.
		AppearDownEffect *m_fx_down_appear; //lorsqu'on appuie sur bas, l'item du dessous apparait
		
		TranslationEffect *m_fx_up_translation; //lorsqu'on appuie sur haut, les items descendent
		AppearUpEffect *m_fx_up_appear; //lorsqu'on appuie sur haut, l'item du dessus apparait
		VanishDownEffect *m_fx_up_vanish; //lorsqu'on appuie sur haut, l'item du bas disparait
		
		int m_state;//=MENUSTATE_WAIT;
		
		int m_distance;
		
	public:
		PDR4CMenuItemManager();
		~PDR4CMenuItemManager();
		void init(string locale, BmpFont * f);
				
		int selectAction();
		bool cancelAction();
		bool nextMenuAction();
		bool previousMenuAction();
		bool nextValueAction();
		bool previousValueAction();
		
		int update(); //retourne une action a effectuer (apres que les anims aient fini).
		
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL);
};

#endif /*PDR4CMENUITEMMANAGER_H_*/








