#ifndef ABSTRACTDIALOG_H_
#define ABSTRACTDIALOG_H_

#include <oslib/oslib.h>
#include "code/framework/fx/effectsLib.h"
#include <string>

using namespace std;

#define DIALOG_NONE 0
#define DIALOG_OK 1
#define DIALOG_YES 2
#define DIALOG_NO 3
#define DIALOG_CANCEL 4

class AbstractDialog
{
	private:
		OSL_IMAGE *m_img_normal;
		OSL_IMAGE *m_img_tinted;
		OSL_IMAGE *m_img_overlay;
		
		ProgressiveAlphaEffect *m_fx_alpha;
		SizeWowEffect *m_fx_size;
		
		ProgressiveAlphaEffect *m_fx_alpha2;
		SizeWowEffect *m_fx_size2;
		
			
	public:
		AbstractDialog(string overlayfilename);
		virtual ~AbstractDialog();
		
		void draw();
		void update();
		int go();
		
		//à surcharger!
		virtual void startSpecific()=0;
		virtual void drawSpecific()=0;
		virtual void updateSpecific()=0;
		virtual int keys()=0;
		
};

#endif /*ABSTRACTDIALOG_H_*/
