#ifndef PIECECOMBO_H_
#define PIECECOMBO_H_

#include "code/game/pieces/abstract/AbstractPiece.h"
#include <oslib/oslib.h>
#include "code/framework/anim/Anim.h"

class PieceCombo : public AbstractPiece
{
	private:		
		Anim *m_anim_destr; //l'animation de destruction
		int m_nbCombos; //nombre de combos restant à effectuer
		//SerialLocalEffect *m_fx_wow; //arrivé à 0, elle "respire" en attendant de péter
		Anim *m_anim_change; //elle brille quand le chiffre change
		
	public:
		PieceCombo(int combos);
		~PieceCombo();
		PieceCombo(const PieceCombo &piece);//copie
   		PieceCombo& operator =(const PieceCombo& piece);
   		
   		PieceCombo * clone() const;
   		
		int getShape(); //shapenum
		int getColor(); //colornum
		int getType(); //typenum
		void setColor(int color);
		void setShape(int shape);
		
		void startDestruct(); //demarre l'anim de destruction
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void update(); 
		bool destructed(); //informe de la fin de l'anim d'explosion
		bool destructing(); //informe qu'elle est en train d'exploser
		
		//pour cette piece, notifie qu'il y a eu un combo ou qu'il doit la faire exploser s'il le faut
		int specialEvent(int e);
		
		void setExplosionTime(float time);
		
};

#endif /*PIECECOMBO_H_*/
