#ifndef PIECEJOKER_H_
#define PIECEJOKER_H_

#include "code/game/pieces/abstract/AbstractPiece.h"
#include <oslib/oslib.h>
#include "code/framework/anim/Anim.h"
#include "code/framework/fx/EffectsLib.h"

class PieceJoker : public AbstractPiece //TODO: parent devrait etre piecesimple
{
	private:
		int m_color_num;
		int m_shape_num;
		OSL_COLOR m_color; //utilisé pour tinter la piece avant dessin
		
		Anim *m_anim_destr;
		
		OSL_IMAGE *m_img_ray1;
		OSL_IMAGE *m_img_ray2;
		
		SizeWowEffect *m_fx_size1;
		SizeWowEffect *m_fx_size2;
		RotationEffect *m_fx_rot1;
		RotationEffect *m_fx_rot2;
		
		bool m_random;
		
		void initFx();
	
	public:
		PieceJoker(int shape, int color);
		PieceJoker(); //aléatoire
		~PieceJoker();
		PieceJoker(const PieceJoker &piece);//copie
   		PieceJoker& operator =(const PieceJoker& piece);
   		
   		PieceJoker * clone() const;
   		
		int getShape(); //shapenum
		int getColor(); //colornum
		int getType(); //typenum
		void setColor(int color);
		void setShape(int shape);
		
		void startDestruct(); //demarre l'anim de destruction
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void update(); 
		bool destructed(); //informe de la fin de l'anim d'explosion
		bool destructing(); //informe qu'elle est en train d'exploser
		
		int specialEvent(int e){return 0;}
		
		bool isRandom();
		
		void setExplosionTime(float time);
};

#endif /*PIECEJOKER_H_*/
