#include "code/game/pieces/impl/PieceShielded.h"
#include "code/game/pieces/PiecesBufferFactory.h"

/////////////////////
//    INSTANCE     //
/////////////////////

PieceShielded::PieceShielded(int shape, int color):PieceSimple(shape, color)
{
	m_shield_image=PiecesBufferFactory::getShieldedImage(shape);
}

PieceShielded::PieceShielded():PieceSimple()
{
	m_shield_image=PiecesBufferFactory::getShieldedImage(m_shape_num);
}

PieceShielded::~PieceShielded()
{
	//m_shield_image n'est qu'un pointeur
}

PieceShielded::PieceShielded(const PieceShielded &piece):PieceSimple(piece)//copie
{
	m_shield_image=PiecesBufferFactory::getShieldedImage(m_shape_num);
}

PieceShielded& PieceShielded::operator =(const PieceShielded& piece)
{
	PieceSimple::operator =(piece);
	
	m_shield_image=PiecesBufferFactory::getShieldedImage(m_shape_num);
	
	return *this;
}

PieceShielded * PieceShielded::clone() const
{
	PieceShielded *p=new PieceShielded(m_shape_num, m_color_num);
	p->m_random=m_random;
	return p;
}

int PieceShielded::getType()
{
	if(destructing() || destructed())
		return PIECE_TYPE_NORMAL; //le bouclier a sauté a ce moment là
	return PIECE_TYPE_SHIELDED;
}

void PieceShielded::setShape(int shape)
{
	PieceSimple::setShape(shape);
	m_shield_image=PiecesBufferFactory::getShieldedImage(shape);
}

void PieceShielded::drawXY(int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	PieceSimple::drawXY(x, y, fx1, fx2, fx3, fx4, fx5);
	
	if(!m_anim_destr->isRunning() && !m_anim_destr->finished())
		fx::drawXY(m_shield_image, x, y, fx1, fx2, fx3, fx4, fx5);
}





