#include "code/game/sound/PleaseWaitSound.h"
#include "code/framework/utils.h"
#include "code/framework/check/loaders.h"
#include <string>
#include <math.h>

using namespace utils;
using namespace std;

#define PWS_MAX_AVAILABLE_SOUNDS 3
#define PWS_CHANNEL 7
//#define PWS_SND_CONSTANT_WAV 88.34355828f
//#define PWS_SND_CONSTANT_BGM 22.10306748466f


PleaseWaitSound::PleaseWaitSound(bool force1)
{
	m_snd1=NULL;
	m_snd2=NULL;
	m_snd1_ms=0;
	m_snd2_ms=0;
	m_timer=new Timer();
	
		//enableDebug();
	if(force1)
		m_nbSounds=1;
	else
		m_nbSounds=random(1,2); //1 ou 2 sons pour une "composition"
		//debug("m_nbSounds="+toString(m_nbSounds));
	//m_sounds=new OSL_SOUND * [m_nbSounds];
	int choices[m_nbSounds];
	
	//selection aleatoire
	for(int i=0;i<m_nbSounds;i++)
	{
		int rand=random(1, PWS_MAX_AVAILABLE_SOUNDS);
		while(soundAlreadyChosen(choices, i, rand))
		{
			rand++;
			if(rand>PWS_MAX_AVAILABLE_SOUNDS)
			{
				rand=1;
			}
		}
		choices[i]=rand;
		//debug("choisi le son num "+toString(rand));
	}
	
	//chargement
	for(int i=0;i<m_nbSounds;i++)
	{
		string filename="res/sounds/pws/pws0"+toString(choices[i])+".wav";
		//debug("chargement de "+filename);
		OSL_SOUND* sound=fwkLoadSoundFileWAV(filename.c_str(), OSL_FMT_NONE); //weird noise when streamed
		//debug("chargement ok");
		//oslSetSoundEndCallback(sound, PleaseWaitSound::pwsSoundEndCallback);
		//debug("callback ok");
		
		
		if(i==0)
		{
			m_snd1=sound;
			//m_snd1_ms=int(m_snd1->size/PWS_SND_CONSTANT_WAV);  //floor(m_snd1->size/PWS_SND_CONSTANT_WAV + 0.5f); //==round
			m_snd1_ms=wavDuration(filename);
		}
		else
		{
			m_snd2=sound;
			//m_snd2_ms=int(m_snd2->size/PWS_SND_CONSTANT_WAV);   //floor(m_snd2->size/PWS_SND_CONSTANT_WAV + 0.5f);
			m_snd2_ms=wavDuration(filename);
		}
	}

	m_currentPlaying=1;
	
}

PleaseWaitSound::~PleaseWaitSound()
{	
	if(m_snd1!=NULL)
		fwkDeleteSound(m_snd1);
	if(m_snd2!=NULL)
		fwkDeleteSound(m_snd2);
	
	delete m_timer;	
}

bool PleaseWaitSound::soundAlreadyChosen(int choices[], int currentChoiceNum, int currentTry)
{
	//aucun son n'a encore été choisi
	if(currentChoiceNum==0)
		return false;
	
	for(int i=0;i<currentChoiceNum;i++)
	{
		if(choices[i]==currentTry)
			return true;
	}
	
	return false;
}

void PleaseWaitSound::start()
{
	oslPlaySound(m_snd1, PWS_CHANNEL);
	m_timer->start();
}

void PleaseWaitSound::update()
{
	long int ms=m_currentPlaying==1?m_snd1_ms:m_snd2_ms;
	if(m_timer->getTime() >= ms)
	{
		if(m_nbSounds==1)
		{
			oslPlaySound(m_snd1, PWS_CHANNEL);
		}
		else
		{
			if(m_currentPlaying==1)
			{
				if(m_nbSounds==2)
				{
					m_currentPlaying=2;
					oslPlaySound(m_snd2, PWS_CHANNEL);
				}
				else
				{
					oslPlaySound(m_snd1, PWS_CHANNEL);
				}
			}
			else
			{
				m_currentPlaying=1;
				oslPlaySound(m_snd1, PWS_CHANNEL);
			}
		}
		
		m_timer->restart();
	}
}
























