#include "code/tests/TestGamePref.h"
#include <oslib/oslib.h>
#include <string>
#include "code/framework/utils.h"
#include "code/game/menus/MenusDefines.h"
#include "code/game/GamePref.h"

using namespace std;
using namespace utils;

//construction
TestGamePref::TestGamePref()
{
	
	m_action=MENU_NOACTION;
	m_skip=false;
	m_string="not loaded";
	m_int=0;
}

//destruction
TestGamePref::~TestGamePref()
{
	
}

//demarrage du menu
int TestGamePref::go()
{
	while(m_action==MENU_NOACTION)
	{
		oslBenchmarkTest(OSL_BENCH_START);
		
		//touches
		m_action=keys();
		if(m_action==MENU_QUIT)
			return m_action;
		
		//phase d'update
		
				
		if (!m_skip)
		{
			//phase de dessin
			oslStartDrawing();
			drawScene();
			oslBenchmarkTest(OSL_BENCH_END);
			oslSysBenchmarkDisplay();
			oslEndDrawing();
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
	}
	//il a choisi une option
	enableDebug();
	debug("fin boucle TestGamePref, return "+toString(m_action));
	enableDebug(false);
	
	return m_action;	
}

//dessins
void TestGamePref::drawScene()
{
	oslClearScreen(RGB(0,0,0));
	
	oslDrawString(10, 240, "R: charger  L: sauver");
	oslDrawString(10, 250, ("string: " + m_string).c_str());
	oslDrawString(10, 260, ("int: " + toString(m_int)).c_str());
}

//gestion des touches
int TestGamePref::keys()
{
	oslReadKeys();
	if (osl_pad.pressed.start) //Exit 
	{
		enableDebug();
		debug("start!");
		enableDebug(false);
		return MENU_MAIN;
	}
	
	//chargement
	if(osl_pad.pressed.R)
	{
		GamePref::load();
		m_string=GamePref::getStrValue("teststr");
		m_int=GamePref::getIntValue("testint");
	}
	
	else if(osl_pad.pressed.L)
	{
		GamePref::save("djdrops_test_saved.properties");
	}
	
	if (osl_pad.pressed.up)
	{
		m_int++;
	}
	else if(osl_pad.pressed.down)
	{
		m_int--;
	}
	else if(osl_pad.pressed.left)
	{
		
	}
	else if(osl_pad.pressed.right)
	{
		
	}
	
	if(osl_pad.pressed.select)
	{
	
	}
	
	return MENU_NOACTION;
}





















































