#include "code/tests/TestNowLoading.h"
#include <pspdisplay.h>
#include <oslib/oslib.h>
#include <string>
#include "code/framework/utils.h"
#include "code/game/menus/MenusDefines.h"
#include "code/game/loading/Loading.h"
#include "code/framework/time/Timer.h"

using namespace std;
using namespace utils;

//construction
TestNowLoading::TestNowLoading()
{
	
	m_action=MENU_NOACTION;
	m_skip=false;
	
	m_img_bg=oslLoadImageFilePNG("res/menus/main/images/fondmenu.png", OSL_IN_RAM, OSL_PF_8888);
}

//destruction
TestNowLoading::~TestNowLoading()
{
	
	oslDeleteImage(m_img_bg);
}

//demarrage du menu
int TestNowLoading::go()
{
	while(m_action==MENU_NOACTION)
	{
		oslBenchmarkTest(OSL_BENCH_START);
		
		//touches
		m_action=keys();
		if(m_action==MENU_QUIT)
			return m_action;
		
		//phase d'update
		
				
		if (!m_skip)
		{
			//phase de dessin
			oslStartDrawing();
			drawScene();
			oslBenchmarkTest(OSL_BENCH_END);
			oslSysBenchmarkDisplay();
			oslEndDrawing();
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
	}
	//il a choisi une option
	enableDebug();
	debug("fin boucle TestNowLoading, return "+toString(m_action));
	enableDebug(false);
	
	return m_action;	
}

//dessins
void TestNowLoading::drawScene()
{
	//oslClearScreen(RGB(0,0,0));
	
	
	//oslDrawString(10,260,"test!");
	oslDrawImageXY(m_img_bg, 0, 0);
	
}

//gestion des touches
int TestNowLoading::keys()
{
	oslReadKeys();
	if (osl_pad.pressed.start) //Exit 
	{
		enableDebug();
		debug("start!");
		enableDebug(false);
		return MENU_MAIN;
	}
	

	if(osl_pad.pressed.cross)
	{
		
		//Timer *t=new Timer();
		//t->start();
		
		Loading::startLoading();
		
		for(int i=0;i<1000;i++)
		{
	      	//wait everytime for the screen blank, total 5 seconds
	      	sceDisplayWaitVblankStart();
	   	}
	   	//int count=0;
	   	/*while(t->getTime()<5000)
	   	{
	   		count++;
	   	}//*/
	   		   
	   	Loading::endLoading();
	   	//delete t;
	   	
	   	//enableDebug();
	   	//debug("nb iterations: "+count);
	   	//enableDebug(false);
	}

	
	
	
	
	if(osl_pad.pressed.select)
	{
	
	}
	
	return MENU_NOACTION;
}












































