#include "code/tests/TestPleaseWaitSound.h"
#include <oslib/oslib.h>
#include "code/game/menus/MenusDefines.h"
#include "code/game/sound/PleaseWaitSound.h"
#include "code/framework/utils.h"

using namespace utils;

//construction
TestPleaseWaitSound::TestPleaseWaitSound()
{
	m_action=MENU_NOACTION;
	m_skip=false;
	
	m_pws=NULL;//new PleaseWaitSound();
	
	m_paused=false;
	
//	OSL_SOUND *snd=oslLoadSoundFileWAV("res/sounds/pws/pws02.wav", OSL_FMT_NONE);
//	enableDebug();
//	debug(toString(snd->size));
//	enableDebug(false);
}

//destruction
TestPleaseWaitSound::~TestPleaseWaitSound()
{	
	if(m_pws!=NULL)
		delete m_pws;
}

//demarrage du menu
int TestPleaseWaitSound::go()
{
	while(m_action==MENU_NOACTION)
	{
		oslBenchmarkTest(OSL_BENCH_START);
		
		//touches
		m_action=keys();
		if(m_action==MENU_QUIT)
			return m_action;
		
		//phase d'update
		if(m_pws!=NULL)
			m_pws->update();
				
		if (!m_skip)
		{
			//phase de dessin
			oslStartDrawing();
			drawScene();
			oslBenchmarkTest(OSL_BENCH_END);
			oslSysBenchmarkDisplay();
			oslEndDrawing();
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
	}
	//il a choisi une option
	enableDebug();
	debug("fin boucle TestPleaseWaitSound, return "+toString(m_action));
	enableDebug(false);
	
	return m_action;	
}

//dessins
void TestPleaseWaitSound::drawScene()
{
	oslClearScreen(RGB(0,0,0));
	
	if(m_paused)
		oslDrawString(200, 150, "pause");
}

//gestion des touches
int TestPleaseWaitSound::keys()
{
	oslReadKeys();
	if (osl_pad.pressed.start) //Exit 
	{
		enableDebug();
		debug("start!");
		enableDebug(false);
		return MENU_MAIN;
	}
	
	
	if(osl_pad.pressed.R)
	{
		
	}
	
	else if(osl_pad.pressed.L)
	{
		
	}
		
		
	if (osl_pad.pressed.up)
	{
		
	}
	else if(osl_pad.pressed.down)
	{
		
	}
	else if(osl_pad.pressed.left)
	{
		
	}
	else if(osl_pad.pressed.right)
	{
		
	}
	
	if(osl_pad.pressed.select)
	{
		//enableDebug();
		//debug("select!");
		
		m_paused=!m_paused;
		if(m_pws!=NULL)
		{
			delete m_pws;
			m_pws=NULL;
		}
		
		if(m_paused)
		{
			//debug("new PleaseWaitSound()...");
			m_pws=new PleaseWaitSound();
		}
		else
		{
			
		}
	}
	
	return MENU_NOACTION;
}





































